"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDeepId = exports.useDeepSubscription = exports.useDeepQuery = exports.useDeep = exports.DeepProvider = exports.useDeepGenerator = exports.DeepContext = exports.useAuthNode = exports.GUEST = exports.WHOISME = exports.JWT = exports.DeepClient = exports.checkAndFillShorts = exports.parseJwt = exports.serializeQuery = exports.serializeWhere = exports.pathToWhere = exports._boolExpFields = exports._serialize = exports._ids = void 0;
const atob_1 = __importDefault(require("atob"));
const index_js_1 = require("@apollo/client/index.js");
const client_js_1 = require("@deep-foundation/hasura/client.js");
const local_js_1 = require("@deep-foundation/store/local.js");
const react_1 = __importStar(require("react"));
const index_js_2 = require("./gql/index.js");
const minilinks_js_1 = require("./minilinks.js");
const promise_js_1 = require("./promise.js");
const react_token_js_1 = require("./react-token.js");
const reserve_js_1 = require("./reserve.js");
const core_js_1 = require("./core.js");
const get_value_1 = __importDefault(require("get-value"));
const debug_js_1 = require("./debug.js");
const moduleLog = debug_js_1.debug.extend('client');
const log = debug_js_1.debug.extend('log');
const error = debug_js_1.debug.extend('error');
const corePckgIds = {};
core_js_1.corePckg.data.filter(l => !!l.type).forEach((l, i) => {
    corePckgIds[l.id] = i + 1;
});
exports._ids = {
    '@deep-foundation/core': corePckgIds,
};
exports._serialize = {
    links: {
        fields: {
            id: 'number',
            from_id: 'number',
            to_id: 'number',
            type_id: 'number',
        },
        relations: {
            from: 'links',
            to: 'links',
            type: 'links',
            in: 'links',
            out: 'links',
            typed: 'links',
            selected: 'selector',
            selectors: 'selector',
            value: 'value',
            string: 'value',
            number: 'value',
            object: 'value',
            can_rule: 'can',
            can_action: 'can',
            can_object: 'can',
            can_subject: 'can',
            down: 'tree',
            up: 'tree',
            tree: 'tree',
            root: 'tree',
        },
    },
    selector: {
        fields: {
            item_id: 'number',
            selector_id: 'number',
            query_id: 'number',
            selector_include_id: 'number',
        },
        relations: {
            item: 'links',
            selector: 'links',
            query: 'links',
        }
    },
    can: {
        fields: {
            rule_id: 'number',
            action_id: 'number',
            object_id: 'number',
            subject_id: 'number',
        },
        relations: {
            rule: 'links',
            action: 'links',
            object: 'links',
            subject: 'links',
        }
    },
    tree: {
        fields: {
            id: 'number',
            link_id: 'number',
            tree_id: 'number',
            root_id: 'number',
            parent_id: 'number',
            depth: 'number',
            position_id: 'string',
        },
        relations: {
            link: 'links',
            tree: 'links',
            root: 'links',
            parent: 'links',
            by_link: 'tree',
            by_tree: 'tree',
            by_root: 'tree',
            by_parent: 'tree',
            by_position: 'tree',
        }
    },
    value: {
        fields: {
            id: 'number',
            link_id: 'number',
            value: 'value',
        },
        relations: {
            link: 'links',
        },
    },
};
exports._boolExpFields = {
    _and: true,
    _not: true,
    _or: true,
};
const pathToWhere = (start, ...path) => {
    const pckg = typeof (start) === 'string' ? { type_id: exports._ids?.['@deep-foundation/core']?.Package, value: start } : { id: start };
    let where = pckg;
    for (let p = 0; p < path.length; p++) {
        const item = path[p];
        if (typeof (item) !== 'boolean') {
            const nextWhere = { in: { type_id: exports._ids?.['@deep-foundation/core']?.Contain, value: item, from: where } };
            where = nextWhere;
        }
    }
    return where;
};
exports.pathToWhere = pathToWhere;
const serializeWhere = (exp, env = 'links') => {
    // if exp is array - map
    if (Object.prototype.toString.call(exp) === '[object Array]')
        return exp.map((e) => (0, exports.serializeWhere)(e, env));
    else if (typeof (exp) === 'object') {
        // if object
        const keys = Object.keys(exp);
        const result = {};
        // map keys
        for (let k = 0; k < keys.length; k++) {
            const key = keys[k];
            const type = typeof (exp[key]);
            if (typeof (exp[key]) === 'undefined')
                throw new Error(`${key} === undefined`);
            let setted = false;
            const is_id_field = !!~['type_id', 'from_id', 'to_id'].indexOf(key);
            // if this is link
            if (env === 'links') {
                // if field contain primitive type - string/number
                if (type === 'string' || type === 'number') {
                    if (key === 'value' || key === type) {
                        // if field id link.value
                        setted = result[type] = { value: { _eq: exp[key] } };
                    }
                    else {
                        // else just equal
                        setted = result[key] = { _eq: exp[key] };
                    }
                }
                else if (!exports._boolExpFields[key] && Object.prototype.toString.call(exp[key]) === '[object Array]') {
                    // if field is not boolExp (_and _or _not) but contain array
                    // @ts-ignore
                    setted = result[key] = (0, exports.serializeWhere)((0, exports.pathToWhere)(...exp[key]));
                }
            }
            else if (env === 'tree') {
                // if field contain primitive type - string/number
                if (type === 'string' || type === 'number') {
                    setted = result[key] = { _eq: exp[key] };
                }
                else if (!exports._boolExpFields[key] && Object.prototype.toString.call(exp[key]) === '[object Array]') {
                    // if field is not boolExp (_and _or _not) but contain array
                    // @ts-ignore
                    setted = result[key] = (0, exports.serializeWhere)((0, exports.pathToWhere)(...exp[key]));
                }
            }
            else if (env === 'value') {
                // if this is value
                if (type === 'string' || type === 'number') {
                    setted = result[key] = { _eq: exp[key] };
                }
            }
            if (type === 'object' && exp[key].hasOwnProperty('_type_of') && ((env === 'links' && (is_id_field || key === 'id')) ||
                (env === 'selector' && key === 'item_id') ||
                (env === 'can' && !!~['rule_id', 'action_id', 'subject_id', 'object_id',].indexOf(key)) ||
                (env === 'tree' && !!~['link_id', 'tree_id', 'root_id', 'parent_id'].indexOf(key)) ||
                (env === 'value' && key === 'link_id'))) {
                // if field is object, and contain _type_od
                const _temp = setted = { _by_item: { path_item_id: { _eq: exp[key]._type_of }, group_id: { _eq: 0 } } };
                if (key === 'id') {
                    result._and = result._and ? [...result._and, _temp] : [_temp];
                }
                else {
                    result[key.slice(0, -3)] = _temp;
                }
            }
            else if (type === 'object' && exp[key].hasOwnProperty('_id') && ((env === 'links' && (is_id_field || key === 'id')) ||
                (env === 'selector' && key === 'item_id') ||
                (env === 'can' && !!~['rule_id', 'action_id', 'subject_id', 'object_id',].indexOf(key)) ||
                (env === 'tree' && !!~['link_id', 'tree_id', 'root_id', 'parent_id'].indexOf(key)) ||
                (env === 'value' && key === 'link_id')) && Object.prototype.toString.call(exp[key]._id) === '[object Array]' && exp[key]._id.length >= 1) {
                // if field is object, and contain _type_od
                const _temp = setted = (0, exports.serializeWhere)((0, exports.pathToWhere)(exp[key]._id[0], ...exp[key]._id.slice(1)), 'links');
                if (key === 'id') {
                    result._and = result._and ? [...result._and, _temp] : [_temp];
                }
                else {
                    result[key.slice(0, -3)] = _temp;
                }
            }
            // if not expected
            if (!setted) {
                const _temp = (
                // if _and _or _not
                exports._boolExpFields[key]) ? (
                // just parse each item in array
                (0, exports.serializeWhere)(exp[key], env)) : (
                // if we know context
                exports._serialize?.[env]?.relations?.[key]) ? (
                // go to this context then
                (0, exports.serializeWhere)(exp[key], exports._serialize?.[env]?.relations?.[key])) : (
                // else just stop
                exp[key]);
                if (key === '_and')
                    result._and ? result._and.push(..._temp) : result._and = _temp;
                else
                    result[key] = _temp;
            }
        }
        return result;
    }
    else {
        if (typeof (exp) === 'undefined')
            throw new Error('undefined in query');
        return exp;
    }
};
exports.serializeWhere = serializeWhere;
const serializeQuery = (exp, env = 'links') => {
    const { limit, order_by, offset, distinct_on, ...where } = exp;
    const result = { where: typeof (exp) === 'object' ? Object.prototype.toString.call(exp) === '[object Array]' ? { id: { _in: exp } } : (0, exports.serializeWhere)(where, env) : { id: { _eq: exp } } };
    // const result: any = { where: serializeWhere(where, env) };
    if (limit)
        result.limit = limit;
    if (order_by)
        result.order_by = order_by;
    if (offset)
        result.offset = offset;
    if (distinct_on)
        result.distinct_on = distinct_on;
    return result;
};
exports.serializeQuery = serializeQuery;
// https://stackoverflow.com/a/38552302/4448999
function parseJwt(token) {
    var base64Url = token.split('.')[1];
    var base64 = base64Url.replace(/-/g, '+').replace(/_/g, '/');
    var jsonPayload = decodeURIComponent((0, atob_1.default)(base64).split('').map(function (c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));
    const parsed = JSON.parse(jsonPayload);
    const { 'x-hasura-allowed-roles': roles, 'x-hasura-default-role': role, 'x-hasura-user-id': userId, ...other } = parsed['https://hasura.io/jwt/claims'] || {};
    return {
        userId: +userId, role, roles,
        ...other,
    };
}
exports.parseJwt = parseJwt;
;
function checkAndFillShorts(obj) {
    for (var i in obj) {
        if (!obj.hasOwnProperty(i))
            continue;
        if ((typeof obj[i]) == 'object' && obj[i] !== null) {
            if (typeof obj[i] === 'object' && i === 'object' && obj[i]?.data?.value === undefined) {
                obj[i] = { data: { value: obj[i] } };
                continue;
            }
            if (typeof obj[i] === 'object' && (i === 'to' || i === 'from' || i === 'in' || i === 'out') && obj[i]?.data === undefined)
                obj[i] = { data: obj[i] };
            checkAndFillShorts(obj[i]);
        }
        else if (i === 'string' && typeof obj[i] === 'string' || i === 'number' && typeof obj[i] === 'number')
            obj[i] = { data: { value: obj[i] } };
    }
}
exports.checkAndFillShorts = checkAndFillShorts;
class DeepClient {
    static resolveDependency;
    useDeepSubscription = useDeepSubscription;
    useDeepQuery = useDeepQuery;
    useMinilinksQuery = (query) => (0, minilinks_js_1.useMinilinksQuery)(this.minilinks, query);
    useMinilinksSubscription = (query) => (0, minilinks_js_1.useMinilinksSubscription)(this.minilinks, query);
    useDeep = useDeep;
    DeepProvider = DeepProvider;
    DeepContext = exports.DeepContext;
    linkId;
    token;
    handleAuth;
    deep;
    client;
    apolloClient;
    minilinks;
    table;
    returning;
    selectReturning;
    linksSelectReturning;
    valuesSelectReturning;
    selectorsSelectReturning;
    filesSelectReturning;
    insertReturning;
    updateReturning;
    deleteReturning;
    defaultSelectName;
    defaultInsertName;
    defaultUpdateName;
    defaultDeleteName;
    silent;
    _silent(options = {}) {
        return typeof (options.silent) === 'boolean' ? options.silent : this.silent;
    }
    constructor(options) {
        this.deep = options.deep;
        if (!this.apolloClient)
            this.apolloClient = options.apolloClient;
        if (!this.deep && !options.apolloClient)
            throw new Error('options.apolloClient or options.deep is required');
        if (this.deep && !this.apolloClient && !options.apolloClient && options.token) {
            this.apolloClient = (0, client_js_1.generateApolloClient)({
                // @ts-ignore
                path: this.deep.apolloClient?.path,
                // @ts-ignore
                ssl: this.deep.apolloClient?.ssl,
                token: options.token,
            });
        }
        if (!this.apolloClient)
            throw new Error('apolloClient is invalid');
        this.client = this.apolloClient;
        // @ts-ignore
        this.minilinks = options.minilinks || new minilinks_js_1.MinilinkCollection();
        this.table = options.table || 'links';
        this.token = options.token;
        if (this.token) {
            const decoded = parseJwt(this.token);
            const linkId = decoded?.userId;
            if (!linkId) {
                throw new Error(`Unable to parse linkId from jwt token.`);
            }
            if (options.linkId && options.linkId !== linkId) {
                throw new Error(`linkId (${linkId}) parsed from jwt token is not the same as linkId passed via options (${options.linkId}).`);
            }
            this.linkId = linkId;
        }
        else {
            this.linkId = options.linkId;
        }
        this.handleAuth = options?.handleAuth || options?.deep?.handleAuth;
        this.linksSelectReturning = options.linksSelectReturning || options.selectReturning || 'id type_id from_id to_id value';
        this.selectReturning = options.selectReturning || this.linksSelectReturning;
        this.valuesSelectReturning = options.valuesSelectReturning || 'id link_id value';
        this.selectorsSelectReturning = options.selectorsSelectReturning || 'item_id selector_id';
        this.filesSelectReturning = options.filesSelectReturning || 'id link_id name mimeType';
        this.insertReturning = options.insertReturning || 'id';
        this.updateReturning = options.updateReturning || 'id';
        this.deleteReturning = options.deleteReturning || 'id';
        this.defaultSelectName = options.defaultSelectName || 'SELECT';
        this.defaultInsertName = options.defaultInsertName || 'INSERT';
        this.defaultUpdateName = options.defaultUpdateName || 'UPDATE';
        this.defaultDeleteName = options.defaultDeleteName || 'DELETE';
        this.silent = options.silent || false;
    }
    stringify(any) {
        if (typeof (any) === 'string') {
            let json;
            try {
                json = JSON.parse(any);
            }
            catch (e) { }
            return json ? JSON.stringify(json, null, 2) : any.toString();
        }
        else if (typeof (any) === 'object') {
            return JSON.stringify(any, null, 2);
        }
        return any;
    }
    serializeQuery = exports.serializeQuery;
    serializeWhere = exports.serializeWhere;
    async select(exp, options) {
        if (!exp) {
            return { error: { message: '!exp' }, data: undefined, loading: false, networkStatus: undefined };
        }
        const query = (0, exports.serializeQuery)(exp, options?.table || 'links');
        const table = options?.table || this.table;
        const returning = options?.returning ??
            (table === 'links' ? this.linksSelectReturning :
                ['strings', 'numbers', 'objects'].includes(table) ? this.valuesSelectReturning :
                    table === 'selectors' ? this.selectorsSelectReturning :
                        table === 'files' ? this.filesSelectReturning : `id`);
        // console.log(`returning: ${returning}; options.returning:${options?.returning}`)
        const variables = options?.variables;
        const name = options?.name || this.defaultSelectName;
        try {
            const q = await this.apolloClient.query((0, index_js_2.generateQuery)({
                queries: [
                    (0, index_js_2.generateQueryData)({
                        tableName: table,
                        returning,
                        variables: {
                            ...variables,
                            ...query,
                        }
                    }),
                ],
                name: name,
            }));
            return { ...q, data: (q)?.data?.q0 };
        }
        catch (e) {
            throw new Error(`DeepClient Select Error: ${e.message}`, { cause: e });
        }
    }
    ;
    async insert(objects, options) {
        const _objects = Object.prototype.toString.call(objects) === '[object Array]' ? objects : [objects];
        checkAndFillShorts(_objects);
        const table = options?.table || this.table;
        const returning = options?.returning || this.insertReturning;
        const variables = options?.variables;
        const name = options?.name || this.defaultInsertName;
        let q = {};
        try {
            q = await this.apolloClient.mutate((0, index_js_2.generateSerial)({
                actions: [(0, index_js_2.insertMutation)(table, { ...variables, objects: _objects }, { tableName: table, operation: 'insert', returning })],
                name: name,
            }));
        }
        catch (e) {
            const sqlError = e?.graphQLErrors?.[0]?.extensions?.internal?.error;
            if (sqlError?.message)
                e.message = sqlError.message;
            if (!this._silent(options))
                throw new Error(`DeepClient Insert Error: ${e.message}`, { cause: e });
            return { ...q, data: (q)?.data?.m0?.returning, error: e };
        }
        // @ts-ignore
        return { ...q, data: (q)?.data?.m0?.returning };
    }
    ;
    async update(exp, value, options) {
        if (exp === null)
            return this.insert([value], options);
        if (value === null)
            return this.delete(exp, options);
        const query = (0, exports.serializeQuery)(exp, options?.table === this.table || !options?.table ? 'links' : 'value');
        const table = options?.table || this.table;
        const returning = options?.returning || this.updateReturning;
        const variables = options?.variables;
        const name = options?.name || this.defaultUpdateName;
        let q;
        try {
            q = await this.apolloClient.mutate((0, index_js_2.generateSerial)({
                actions: [(0, index_js_2.updateMutation)(table, { ...variables, ...query, _set: value }, { tableName: table, operation: 'update', returning })],
                name: name,
            }));
        }
        catch (e) {
            const sqlError = e?.graphQLErrors?.[0]?.extensions?.internal?.error;
            if (sqlError?.message)
                e.message = sqlError.message;
            if (!this._silent(options))
                throw new Error(`DeepClient Update Error: ${e.message}`, { cause: e });
            return { ...q, data: (q)?.data?.m0?.returning, error: e };
        }
        // @ts-ignore
        return { ...q, data: (q)?.data?.m0?.returning };
    }
    ;
    async delete(exp, options) {
        if (!exp)
            throw new Error('!exp');
        const query = (0, exports.serializeQuery)(exp, options?.table === this.table || !options?.table ? 'links' : 'value');
        const table = options?.table || this.table;
        const returning = options?.returning || this.deleteReturning;
        const variables = options?.variables;
        const name = options?.name || this.defaultDeleteName;
        let q;
        try {
            q = await this.apolloClient.mutate((0, index_js_2.generateSerial)({
                actions: [(0, index_js_2.deleteMutation)(table, { ...variables, ...query, returning }, { tableName: table, operation: 'delete', returning })],
                name: name,
            }));
            // @ts-ignore
        }
        catch (e) {
            const sqlError = e?.graphQLErrors?.[0]?.extensions?.internal?.error;
            if (sqlError?.message)
                e.message = sqlError.message;
            if (!this._silent(options))
                throw new Error(`DeepClient Delete Error: ${e.message}`, { cause: e });
            return { ...q, data: (q)?.data?.m0?.returning, error: e };
        }
        return { ...q, data: (q)?.data?.m0?.returning };
    }
    ;
    async serial({ name, operations, returning, silent }) {
        // @ts-ignore
        let operationsGroupedByTypeAndTable = {};
        operationsGroupedByTypeAndTable = operations.reduce((acc, operation) => {
            if (!acc[operation.type]) {
                // @ts-ignore
                acc[operation.type] = {};
            }
            if (!acc[operation.type][operation.table]) {
                acc[operation.type][operation.table] = [];
            }
            acc[operation.type][operation.table].push(operation);
            return acc;
        }, operationsGroupedByTypeAndTable);
        let serialActions = [];
        Object.keys(operationsGroupedByTypeAndTable).map((operationType) => {
            const operationsGroupedByTable = operationsGroupedByTypeAndTable[operationType];
            Object.keys(operationsGroupedByTable).map((table) => {
                const operations = operationsGroupedByTable[table];
                if (operationType === 'insert') {
                    const insertOperations = operations;
                    const serialAction = (0, index_js_2.insertMutation)(table, { objects: insertOperations.map(operation => Array.isArray(operation.objects) ? operation.objects : [operation.objects]).flat() }, { tableName: table, operation: operationType, returning });
                    serialActions.push(serialAction);
                }
                else if (operationType === 'update') {
                    const updateOperations = operations;
                    const newSerialActions = updateOperations.map(operation => {
                        const exp = operation.exp;
                        const value = operation.value;
                        const query = (0, exports.serializeQuery)(exp, table === this.table || !table ? 'links' : 'value');
                        return (0, index_js_2.updateMutation)(table, { ...query, _set: value }, { tableName: table, operation: operationType, returning });
                    });
                    serialActions = [...serialActions, ...newSerialActions];
                }
                else if (operationType === 'delete') {
                    const deleteOperations = operations;
                    ;
                    const newSerialActions = deleteOperations.map(operation => {
                        const exp = operation.exp;
                        const query = (0, exports.serializeQuery)(exp, table === this.table || !table ? 'links' : 'value');
                        return (0, index_js_2.deleteMutation)(table, { ...query }, { tableName: table, operation: operationType, returning });
                    });
                    serialActions = [...serialActions, ...newSerialActions];
                }
            });
        });
        let result;
        try {
            result = await this.apolloClient.mutate((0, index_js_2.generateSerial)({
                actions: serialActions,
                name: name ?? 'Name',
            }));
            // @ts-ignore
        }
        catch (e) {
            const sqlError = e?.graphQLErrors?.[0]?.extensions?.internal?.error;
            if (sqlError?.message)
                e.message = sqlError.message;
            if (!silent)
                throw new Error(`DeepClient Serial Error: ${e.message}`, { cause: e });
            return { ...result, data: (result)?.data?.m0?.returning, error: e };
        }
        // @ts-ignore
        return { ...result, data: (result)?.data && Object.values((result)?.data).flatMap(m => m.returning) };
    }
    ;
    reserve(count) {
        return (0, reserve_js_1.reserve)({ count, client: this.apolloClient });
    }
    ;
    async await(id, options = { results: false }) {
        return (0, promise_js_1.awaitPromise)({
            id, client: this.apolloClient,
            Then: await this.id('@deep-foundation/core', 'Then'),
            Promise: await this.id('@deep-foundation/core', 'Promise'),
            Resolved: await this.id('@deep-foundation/core', 'Resolved'),
            Rejected: await this.id('@deep-foundation/core', 'Rejected'),
            Results: options.results
        });
    }
    ;
    /**
     * Find id of link by packageName/id as first argument, and Contain value (name) as path items.
     * @description Thows error if id is not found. You can set last argument true, for disable throwing error.
     * @returns number
     */
    async id(start, ...path) {
        if (typeof (start) === 'object') {
            return (await this.select(start))?.data?.[0]?.id;
        }
        if (exports._ids?.[start]?.[path[0]]) {
            return exports._ids[start][path[0]];
        }
        const q = await this.select((0, exports.pathToWhere)(start, ...path));
        if (q.error) {
            throw q.error;
        }
        // @ts-ignore
        const result = (q?.data?.[0]?.id | exports._ids?.[start]?.[path?.[0]] | 0);
        if (!result && path[path.length - 1] !== true) {
            throw new Error(`Id not found by [${JSON.stringify([start, ...path])}]`);
        }
        return result;
    }
    ;
    /**
     * This function fetches the corresponding IDs from the Deep for each specified path.
     *
     * @async
     * @function ids
     * @param {Array<[DeepClientStartItem, ...DeepClientPathItem[]]>} paths - An array of [start, ...path] tuples.
     *     Each tuple specifies a path to a link, where 'start' is the package name or id
     *     and ...path further specifies the path to the id using Contain link values (names).
     *
     * @returns {Promise<any>} - Returns a Promise that resolves to an object.
     *    The object has keys corresponding to the package name or id of each path.
     *    The value for each package key is an object where keys are the items in the corresponding path,
     *    and the values are the IDs retrieved from the Deep.
     *
     * @throws Will throw an error if the id retrieval fails in `this.id()` function.
     *
     * @example
     * ```ts
     *   const ids = await deep.ids([
     *     ['@deep-foundation/core', 'Package'],
     *     ['@deep-foundation/core', 'PackageVersion']
     *   ]);
     *
     *   // Outputs
     *   // {
     *   //   "@deep-foundation/core": {
     *   //     "Package": 2,
     *   //     "PackageVersion": 46
     *   //   }
     *   // }
     * ```
     */
    async ids(...paths) {
        // TODO: it can be faster using a combiniation of simple select of packages and contains with specified names and recombination of these links in minilinks
        // At the moment it may be slow, but it demonstrates desired API.
        const appendPath = (accumulator, keys, value) => {
            const lastKey = keys.pop();
            const lastObject = keys.reduce((obj, key) => obj[key] = obj[key] || {}, accumulator);
            lastObject[lastKey] = value;
        };
        const result = {};
        await Promise.all(paths.map(async ([start, ...path]) => {
            const id = await this.id(start, ...path);
            appendPath(result, [start, ...path], id);
        }));
        return result;
    }
    idLocal(start, ...path) {
        const paths = [start, ...path];
        if ((0, get_value_1.default)(exports._ids, paths.join('.'))) {
            return (0, get_value_1.default)(exports._ids, paths.join('.'));
        }
        // let result: number;
        // if(paths.length === 1) {
        // } else {
        //   result = paths[0] as number;
        //   for (let i = 1; i < paths.length; i++) {
        //     result = this.idLocal(result, paths[i] as Exclude<DeepClientPathItem, boolean>);
        // }
        // }
        const [link] = this.minilinks.query({
            id: {
                _id: paths
            }
        });
        const result = link?.id;
        if (!result) {
            throw new Error(`Id not found by ${JSON.stringify([start, ...path])}`);
        }
        else {
            return result;
        }
    }
    ;
    async guest(options = {}) {
        const relogin = typeof (options.relogin) === 'boolean' ? options.relogin : true;
        const result = await this.apolloClient.query({ query: exports.GUEST });
        const { linkId, token, error } = result?.data?.guest || {};
        if (!error && !!token && relogin) {
            if (this?.handleAuth)
                setTimeout(() => this?.handleAuth(+linkId, token), 0);
        }
        return { linkId, token, error: !error && (!linkId || !token) ? 'unexepted' : error };
    }
    ;
    async jwt(options) {
        const relogin = typeof (options.relogin) === 'boolean' ? options.relogin : false;
        if (options?.token) {
            try {
                const token = options?.token;
                const decoded = parseJwt(token);
                const linkId = decoded?.userId;
                if (!!token && relogin) {
                    if (this?.handleAuth)
                        setTimeout(() => this?.handleAuth(+linkId, token), 0);
                }
                return { linkId, token, error: (!linkId || !token) ? 'unexepted' : undefined };
            }
            catch (e) {
                return { error: e };
            }
        }
        else if (options?.linkId) {
            const result = await this.apolloClient.query({ query: exports.JWT, variables: { linkId: +options.linkId } });
            const { linkId, token, error } = result?.data?.jwt || {};
            if (!error && !!token && relogin) {
                if (this?.handleAuth)
                    setTimeout(() => this?.handleAuth(+linkId, token), 0);
            }
            return { linkId, token, error: error ? error : (!linkId) ? 'unexepted' : undefined };
        }
        else
            return { error: `linkId or token must be provided` };
    }
    ;
    /**
     * Return is of current authorized user linkId.
     * Refill client.linkId and return.
     */
    async whoami() {
        const result = await this.apolloClient.query({ query: exports.WHOISME });
        this.linkId = result?.data?.jwt?.linkId;
        return result?.data?.jwt?.linkId;
    }
    async login(options) {
        const jwtResult = await this.jwt({ ...options, relogin: true });
        this.token = jwtResult.token;
        this.linkId = jwtResult.linkId;
        return jwtResult;
    }
    ;
    async logout() {
        if (this?.handleAuth)
            setTimeout(() => this?.handleAuth(0, ''), 0);
        return { linkId: 0, token: '' };
    }
    ;
    async can(objectIds, subjectIds, actionIds, userIds = this.linkId) {
        const where = {};
        if (objectIds)
            where.object_id = typeof (objectIds) === 'number' ? { _eq: +objectIds } : { _in: objectIds };
        if (subjectIds)
            where.subject_id = typeof (subjectIds) === 'number' ? { _eq: +subjectIds } : { _in: subjectIds };
        if (actionIds)
            where.action_id = typeof (actionIds) === 'number' ? { _eq: +actionIds } : { _in: actionIds };
        const result = await this.select(where, { table: 'can', returning: 'rule_id' });
        return !!result?.data?.length;
    }
    async name(input) {
        const id = typeof (input) === 'number' ? input : input.id;
        const { data: [containLink] } = await this.select({
            type_id: { _id: ['@deep-foundation/core', 'Contain'] },
            to_id: id,
        });
        // @ts-ignore
        return containLink?.value?.value;
    }
    ;
    nameLocal(input) {
        const id = typeof (input) === 'number' ? input : input?.id;
        if (!id)
            return;
        // @ts-ignore
        return this.minilinks.byType[this.idLocal('@deep-foundation/core', 'Contain')]?.find((c) => c?.to_id === id)?.value?.value;
    }
    async import(path) {
        if (typeof DeepClient.resolveDependency !== 'undefined') {
            try {
                return await DeepClient.resolveDependency(path);
            }
            catch (e) {
                console.log(`IGNORED ERROR: Call to DeepClient.resolveDependency is failed with`, e);
            }
        }
        if (typeof require !== 'undefined') {
            try {
                return await require(path);
            }
            catch (e) {
                console.log(`IGNORED ERROR: Call to require is failed with`, e);
            }
        }
        return await Promise.resolve(`${path}`).then(s => __importStar(require(s)));
    }
}
exports.DeepClient = DeepClient;
exports.JWT = (0, index_js_1.gql) `query JWT($linkId: Int) {
  jwt(input: {linkId: $linkId}) {
    linkId
    token
  }
}`;
exports.WHOISME = (0, index_js_1.gql) `query WHOISME {
  jwt(input: {}) {
    linkId
  }
}`;
exports.GUEST = (0, index_js_1.gql) `query GUEST {
  guest {
    linkId
    token
  }
}`;
function useAuthNode() {
    return (0, local_js_1.useLocalStore)('use_auth_link_id', 0);
}
exports.useAuthNode = useAuthNode;
exports.DeepContext = (0, react_1.createContext)(undefined);
function useDeepGenerator(apolloClientProps) {
    const log = debug_js_1.debug.extend(useDeepGenerator.name);
    const apolloClientHook = (0, index_js_1.useApolloClient)();
    log({ apolloClientHook });
    const apolloClient = apolloClientProps || apolloClientHook;
    log({ apolloClient });
    const [linkId, setLinkId] = useAuthNode();
    log({ linkId, setLinkId });
    const [token, setToken] = (0, react_token_js_1.useTokenController)();
    log({ token, setToken });
    const deep = (0, react_1.useMemo)(() => {
        if (!apolloClient?.jwt_token) {
            log({ token, apolloClient });
        }
        return new DeepClient({
            apolloClient, linkId, token,
            handleAuth: (linkId, token) => {
                setToken(token);
                setLinkId(linkId);
            },
        });
    }, [apolloClient]);
    log({ deep });
    return deep;
}
exports.useDeepGenerator = useDeepGenerator;
function DeepProvider({ apolloClient: apolloClientProps, children, }) {
    const deep = useDeepGenerator(apolloClientProps);
    return react_1.default.createElement(exports.DeepContext.Provider, { value: deep }, children);
}
exports.DeepProvider = DeepProvider;
function useDeep() {
    return (0, react_1.useContext)(exports.DeepContext);
}
exports.useDeep = useDeep;
function useDeepQuery(query, options) {
    const [miniName] = (0, react_1.useState)(options?.mini || Math.random().toString(36).slice(2, 7));
    (0, debug_js_1.debug)('useDeepQuery', miniName, query, options);
    const deep = useDeep();
    const wq = (0, react_1.useMemo)(() => {
        const sq = (0, exports.serializeQuery)(query);
        return (0, index_js_2.generateQuery)({
            operation: 'query',
            queries: [(0, index_js_2.generateQueryData)({
                    tableName: 'links',
                    returning: `
          id type_id from_id to_id value
          string { id value }
          number { id value }
          object { id value }
        `,
                    ...options,
                    variables: { ...sq, ...options?.variables }
                })],
            name: options?.name || 'USE_DEEP_QUERY',
        });
    }, [query, options]);
    const result = (0, index_js_1.useQuery)(wq.query, { variables: wq?.variables });
    (0, minilinks_js_1.useMinilinksApply)(deep.minilinks, miniName, result?.data?.q0 || []);
    const mlResult = deep.useMinilinksSubscription({ id: { _in: result?.data?.q0?.map(l => l.id) } });
    return {
        ...result,
        data: mlResult,
    };
}
exports.useDeepQuery = useDeepQuery;
function useDeepSubscription(query, options) {
    const [miniName] = (0, react_1.useState)(options?.mini || Math.random().toString(36).slice(2, 7));
    (0, debug_js_1.debug)('useDeepSubscription', miniName, query, options);
    const deep = useDeep();
    const wq = (0, react_1.useMemo)(() => {
        const sq = (0, exports.serializeQuery)(query);
        return (0, index_js_2.generateQuery)({
            operation: 'subscription',
            queries: [(0, index_js_2.generateQueryData)({
                    tableName: 'links',
                    returning: `
          id type_id from_id to_id value
          string { id value }
          number { id value }
          object { id value }
        `,
                    ...options,
                    variables: { ...sq, ...options?.variables }
                })],
            name: options?.name || 'USE_DEEP_SUBSCRIPTION',
        });
    }, [query, options]);
    const result = (0, index_js_1.useSubscription)(wq.query, { variables: wq?.variables });
    (0, minilinks_js_1.useMinilinksApply)(deep.minilinks, miniName, result?.data?.q0 || []);
    const mlResult = (0, minilinks_js_1.useMinilinksSubscription)(deep.minilinks, { id: { _in: result?.data?.q0?.map(l => l.id) } });
    return {
        ...result,
        data: mlResult,
    };
}
exports.useDeepSubscription = useDeepSubscription;
function useDeepId(start, ...path) {
    const result = useDeepQuery({ id: { _id: [start, ...path] } });
    return { data: result?.data?.[0]?.id, loading: result?.loading, error: result?.error };
}
exports.useDeepId = useDeepId;
//# sourceMappingURL=client.js.map