"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenProvider = exports.useTokenController = void 0;
const react_1 = __importDefault(require("react"));
const token_context_js_1 = require("@deep-foundation/react-hasura/token-context.js");
const local_js_1 = require("@deep-foundation/store/local.js");
const cookies_js_1 = require("@deep-foundation/store/cookies.js");
function useTokenController(defaultValue = '') {
    const [localToken, setLocalToken] = (0, local_js_1.useLocalStore)('dc-dg-token', defaultValue);
    const [cookieToken, setCookieToken] = (0, cookies_js_1.useCookiesStore)('dc-dg-token', defaultValue);
    return [localToken || cookieToken, (newToken) => {
            const result = setLocalToken(newToken);
            setCookieToken(newToken);
            return result;
        }];
}
exports.useTokenController = useTokenController;
function TokenProvider({ children }) {
    const [token, setToken] = useTokenController();
    // @ts-ignore
    return react_1.default.createElement(token_context_js_1.TokenContext.Provider, { value: token }, children);
}
exports.TokenProvider = TokenProvider;
//# sourceMappingURL=react-token.js.map