"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.api = void 0;
const index_js_1 = require("../gql/index.js");
const api_js_1 = require("@deep-foundation/hasura/api.js");
const client_js_1 = require("@deep-foundation/hasura/client.js");
const RESERVED_LIFETIME_MS = +process.env.RESERVED_LIFETIME || 24 * 60 * 60 * 1000;
exports.api = new api_js_1.HasuraApi({
    path: process.env.DEEPLINKS_HASURA_PATH,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
const client = (0, client_js_1.generateApolloClient)({
    path: `${process.env.DEEPLINKS_HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
exports.default = async (req, res) => {
    try {
        const body = req?.body;
        const result = await client.query((0, index_js_1.generateQuery)({
            queries: [
                (0, index_js_1.generateQueryData)({ tableName: 'reserved', returning: `reserved_ids`, variables: { where: {
                            created_at: {
                                _lt: new Date(Date.now() - RESERVED_LIFETIME_MS)
                            }
                        } } }),
            ],
            name: 'CRON_RESERVED',
        }));
        return res.json({ cleaned: [] });
    }
    catch (e) {
        return res.status(500).json({ error: e.toString() });
    }
};
//# sourceMappingURL=reserved-cleaner.js.map