"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.down = exports.up = exports.MP_TABLE_NAME = void 0;
const api_js_1 = require("@deep-foundation/hasura/api.js");
const client_js_1 = require("@deep-foundation/hasura/client.js");
const trigger_js_1 = require("@deep-foundation/materialized-path/trigger.js");
const debug_1 = __importDefault(require("debug"));
const client_js_2 = require("../imports/client.js");
const _1616701513782_links_js_1 = require("./1616701513782-links.js");
const client_js_3 = require("../imports/client.js");
const debug = (0, debug_1.default)('deeplinks:migrations:type-mp');
const log = debug.extend('log');
const error = debug.extend('error');
const client = (0, client_js_1.generateApolloClient)({
    path: `${process.env.MIGRATIONS_HASURA_PATH}/v1/graphql`,
    ssl: !!+(process.env.MIGRATIONS_HASURA_SSL || 0),
    secret: process.env.MIGRATIONS_HASURA_SECRET,
});
const deep = new client_js_2.DeepClient({
    apolloClient: client,
});
const api = new api_js_1.HasuraApi({
    path: process.env.MIGRATIONS_HASURA_PATH,
    ssl: !!+(process.env.MIGRATIONS_HASURA_SSL || 0),
    secret: process.env.MIGRATIONS_HASURA_SECRET,
});
exports.MP_TABLE_NAME = 'mp';
const createTrigger = async () => {
    return (0, trigger_js_1.Trigger)({
        from_field: 'type_id',
        mpTableName: exports.MP_TABLE_NAME,
        graphTableName: _1616701513782_links_js_1.TABLE_NAME,
        id_type: 'bigint',
        iteratorInsertDeclare: `groupRow bigint DEFAULT ${client_js_3._ids?.['@deep-foundation/core']?.typesTree};`,
        iteratorDeleteArgumentSend: 'groupRow',
        iteratorDeleteArgumentGet: `groupRow bigint = ${client_js_3._ids?.['@deep-foundation/core']?.typesTree}`,
        iteratorInsertBegin: ``,
        iteratorInsertEnd: '',
        groupInsert: 'groupRow',
        iteratorDeleteDeclare: `groupRow bigint DEFAULT ${client_js_3._ids?.['@deep-foundation/core']?.typesTree};`,
        iteratorDeleteBegin: ``,
        iteratorDeleteEnd: '',
        groupDelete: 'groupRow',
        // TODO optimize duplicating equal selects
        isAllowSpreadFromCurrent: `TRUE`,
        isAllowSpreadCurrentTo: `FALSE`,
        isAllowSpreadToCurrent: `FALSE`,
        isAllowSpreadCurrentFrom: `FALSE`,
        isAllowSpreadToInCurrent: `FALSE`,
        isAllowSpreadCurrentFromOut: `FALSE`,
        isAllowSpreadFromOutCurrent: `FALSE`,
        isAllowSpreadCurrentToIn: `FALSE`,
        postfix: '__type',
    });
};
const up = async () => {
    log('up');
    const trigger = await createTrigger();
    await api.sql(trigger.upFunctionInsertNode());
    await api.sql(trigger.upFunctionDeleteNode());
    await api.sql(trigger.upTriggerDelete());
    await api.sql(trigger.upTriggerInsert());
};
exports.up = up;
const down = async () => {
    const trigger = await createTrigger();
    log('down');
    log('dropTrigger');
    await api.sql(trigger.downFunctionInsertNode());
    await api.sql(trigger.downFunctionDeleteNode());
    await api.sql(trigger.downTriggerDelete());
    await api.sql(trigger.downTriggerInsert());
};
exports.down = down;
//# sourceMappingURL=1621815803592-type-mp.js.map