"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.down = exports.up = void 0;
const client_js_1 = require("@deep-foundation/hasura/client.js");
const debug_1 = __importDefault(require("debug"));
const client_js_2 = require("../imports/client.js");
const deep_json_1 = __importDefault(require("@deep-foundation/npm-packager/deep.json"));
const _1664940577200_tsx_js_1 = require("./1664940577200-tsx.js");
const debug = (0, debug_1.default)('deeplinks:migrations:npm-packager');
const log = debug.extend('log');
const error = debug.extend('error');
const rootClient = (0, client_js_1.generateApolloClient)({
    path: `${process.env.MIGRATIONS_HASURA_PATH}/v1/graphql`,
    ssl: !!+(process.env.MIGRATIONS_HASURA_SSL || 0),
    secret: process.env.MIGRATIONS_HASURA_SECRET,
});
const root = new client_js_2.DeepClient({
    apolloClient: rootClient,
});
const up = async () => {
    log('up');
    if (!await (0, _1664940577200_tsx_js_1.packageExists)('@deep-foundation/npm-packager')) {
        const importResult = await (0, _1664940577200_tsx_js_1.importPackage)(deep_json_1.default);
        log(importResult);
        const packageId = importResult.packageId;
        const adminId = await root.id('deep', 'admin');
        await (0, _1664940577200_tsx_js_1.sharePermissions)(adminId, packageId);
        await (0, _1664940577200_tsx_js_1.containWithin)(adminId, packageId);
    }
};
exports.up = up;
const down = async () => {
    log('down');
};
exports.down = down;
//# sourceMappingURL=1677340638677-npm-packager.js.map