"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.down = exports.up = void 0;
const client_js_1 = require("@deep-foundation/hasura/client.js");
const debug_1 = __importDefault(require("debug"));
const client_js_2 = require("../imports/client.js");
const _1678940577209_deepcase_js_1 = require("./1678940577209-deepcase.js");
const _1664940577200_tsx_js_1 = require("./1664940577200-tsx.js");
const debug = (0, debug_1.default)('deeplinks:migrations:npm-packager-ui');
const log = debug.extend('log');
const error = debug.extend('error');
const rootClient = (0, client_js_1.generateApolloClient)({
    path: `${process.env.MIGRATIONS_HASURA_PATH}/v1/graphql`,
    ssl: !!+(process.env.MIGRATIONS_HASURA_SSL || 0),
    secret: process.env.MIGRATIONS_HASURA_SECRET,
});
const root = new client_js_2.DeepClient({
    apolloClient: rootClient,
});
const up = async () => {
    log('up');
    const packageName = '@deep-foundation/npm-packager-ui';
    if (!await (0, _1664940577200_tsx_js_1.packageExists)(packageName)) {
        const adminId = await root.id('deep', 'admin');
        const admin = await root.login({ linkId: adminId });
        const deep = new client_js_2.DeepClient({ deep: root, ...admin });
        const packageId = await (0, _1678940577209_deepcase_js_1.installPackage)(deep, packageName);
        await (0, _1664940577200_tsx_js_1.sharePermissions)(adminId, packageId);
    }
};
exports.up = up;
const down = async () => {
    log('down');
};
exports.down = down;
//# sourceMappingURL=1680017137379-npm-packager-ui.js.map