"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.down = exports.up = exports.dropJsonschemaFabric = exports.createJsonschemaFabric = exports.dropMathjsFabric = exports.createMathjsFabric = void 0;
const debug_1 = __importDefault(require("debug"));
const _1616701513782_links_js_1 = require("./1616701513782-links.js");
const sql_js_1 = require("@deep-foundation/hasura/sql.js");
const debug = (0, debug_1.default)('deeplinks:migrations:plv8');
const log = debug.extend('log');
const error = debug.extend('error');
const mathjsPackage = require('../bundles/mathjs.js').code;
const jsonschemaPackage = require('../bundles/jsonschema.js').code;
exports.createMathjsFabric = (0, sql_js_1.sql) `CREATE OR REPLACE FUNCTION ${_1616701513782_links_js_1.TABLE_NAME}__sync__handlers__mathjs__package() RETURNS jsonb AS $package$ const sync__handlers__package = ${mathjsPackage}; return sync__handlers__package(); $package$ LANGUAGE plv8;`;
exports.dropMathjsFabric = (0, sql_js_1.sql) `DROP FUNCTION IF EXISTS ${_1616701513782_links_js_1.TABLE_NAME}__sync__handlers__mathjs__package CASCADE;`;
exports.createJsonschemaFabric = (0, sql_js_1.sql) `CREATE OR REPLACE FUNCTION ${_1616701513782_links_js_1.TABLE_NAME}__sync__handlers__jsonschema__package() RETURNS jsonb AS $package$ const sync__handlers__package = ${jsonschemaPackage}; return sync__handlers__package(); $package$ LANGUAGE plv8;`;
exports.dropJsonschemaFabric = (0, sql_js_1.sql) `DROP FUNCTION IF EXISTS ${_1616701513782_links_js_1.TABLE_NAME}__sync__handlers__jsonschema__package CASCADE;`;
const up = async () => {
    log('up');
    await _1616701513782_links_js_1.api.sql(exports.createMathjsFabric);
    await _1616701513782_links_js_1.api.sql(exports.createJsonschemaFabric);
};
exports.up = up;
const down = async () => {
    log('down');
    await _1616701513782_links_js_1.api.sql(exports.dropJsonschemaFabric);
    await _1616701513782_links_js_1.api.sql(exports.dropMathjsFabric);
};
exports.down = down;
//# sourceMappingURL=1682327540225-mathjs-schema-packages.js.map