"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.down = exports.up = exports.HEALTHZ_VIEW_NAME = void 0;
const client_js_1 = require("@deep-foundation/hasura/client.js");
const sql_js_1 = require("@deep-foundation/hasura/sql.js");
const debug_1 = __importDefault(require("debug"));
const client_js_2 = require("../imports/client.js");
const _1616701513782_links_js_1 = require("./1616701513782-links.js");
const debug = (0, debug_1.default)('deeplinks:migrations:healthz');
const log = debug.extend('log');
const error = debug.extend('error');
exports.HEALTHZ_VIEW_NAME = 'healthz';
const client = (0, client_js_1.generateApolloClient)({
    path: `${process.env.MIGRATIONS_HASURA_PATH}/v1/graphql`,
    ssl: !!+(process.env.MIGRATIONS_HASURA_SSL || 0),
    secret: process.env.MIGRATIONS_HASURA_SECRET,
});
const deep = new client_js_2.DeepClient({
    apolloClient: client,
});
const up = async () => {
    log('up');
    log('view');
    await _1616701513782_links_js_1.api.sql((0, sql_js_1.sql) `CREATE VIEW ${exports.HEALTHZ_VIEW_NAME} AS SELECT 'ok'::text as "status";`);
    await _1616701513782_links_js_1.api.query({
        type: 'track_table',
        args: {
            schema: _1616701513782_links_js_1.SCHEMA,
            name: exports.HEALTHZ_VIEW_NAME,
        },
    });
    await _1616701513782_links_js_1.api.query({
        type: 'create_select_permission',
        args: {
            table: exports.HEALTHZ_VIEW_NAME,
            role: 'undefined',
            permission: {
                columns: '*',
                filter: {},
                limit: 999,
                allow_aggregations: true
            }
        }
    });
};
exports.up = up;
const down = async () => {
    log('down');
    log('view');
    await _1616701513782_links_js_1.api.query({
        type: 'drop_select_permission',
        args: {
            table: exports.HEALTHZ_VIEW_NAME,
            role: 'undefined',
        }
    });
    await _1616701513782_links_js_1.api.query({
        type: 'untrack_table',
        args: {
            table: {
                schema: _1616701513782_links_js_1.SCHEMA,
                name: exports.HEALTHZ_VIEW_NAME,
            },
            cascade: true,
        },
    });
    await _1616701513782_links_js_1.api.sql((0, sql_js_1.sql) `
    DROP VIEW IF EXISTS ${exports.HEALTHZ_VIEW_NAME} CASCADE;
  `);
};
exports.down = down;
//# sourceMappingURL=1689630159473-healthz.js.map