"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const client_js_1 = require("@deep-foundation/hasura/client.js");
const client_1 = require("../imports/client");
const chai_1 = require("chai");
const apolloClient = (0, client_js_1.generateApolloClient)({
    path: `${process.env.DEEPLINKS_HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
const deep = new client_1.DeepClient({ apolloClient });
describe('demo', () => {
    it(`user can basic dc operations`, async () => {
        const g1 = await deep.guest();
        const d1 = new client_1.DeepClient({ deep, ...g1 });
        const i1s1 = await d1.insert({ type_id: await d1.id('@deep-foundation/core', 'Space') });
        const i1c1 = await d1.insert({ type_id: await d1.id('@deep-foundation/core', 'Contain'), from_id: g1.linkId, to_id: i1s1?.data?.[0]?.id });
        (0, chai_1.expect)(i1s1?.data?.[0]?.id).is.not.undefined;
        const i1q1 = await d1.insert({ type_id: await d1.id('@deep-foundation/core', 'Query'), object: { data: { value: { limit: 0 } } } });
        (0, chai_1.expect)(i1q1?.data?.[0]?.id).is.not.undefined;
        const i1c2 = await d1.insert({ type_id: await d1.id('@deep-foundation/core', 'Contain'), from_id: i1s1?.data?.[0]?.id, to_id: i1q1?.data?.[0]?.id });
        (0, chai_1.expect)(i1c1?.data?.[0]?.id).is.not.undefined;
        const u1q1 = await d1.update({ link_id: { _eq: i1q1?.data?.[0]?.id } }, { value: { limit: 1 } }, { table: 'objects' });
        const s1q1 = await d1.select(i1q1?.data?.[0]?.id);
        (0, chai_1.expect)(s1q1?.data?.[0]?.value?.value?.limit).is.equal(1);
        const i1f1 = await d1.insert({ type_id: await d1.id('@deep-foundation/core', 'Focus'), from_id: i1s1?.data?.[0]?.id, to_id: i1q1?.data?.[0]?.id });
        const i1c3 = await d1.insert({ type_id: await d1.id('@deep-foundation/core', 'Contain'), from_id: i1s1?.data?.[0]?.id, to_id: i1f1?.data?.[0]?.id });
        const s1f1 = await d1.select(i1f1?.data?.[0]?.id);
        (0, chai_1.expect)(s1f1?.data?.[0]?.id).is.not.undefined;
    });
});
//# sourceMappingURL=demo.js.map