"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const client_js_1 = require("@deep-foundation/hasura/client.js");
const client_1 = require("../imports/client");
const chai_1 = require("chai");
const apolloClient = (0, client_js_1.generateApolloClient)({
    path: `${process.env.DEEPLINKS_HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
const root = new client_1.DeepClient({ apolloClient });
let adminToken;
let deep;
beforeAll(async () => {
    const { linkId, token } = await root.jwt({ linkId: await root.id('deep', 'admin') });
    adminToken = token;
    deep = new client_1.DeepClient({ deep: root, token: adminToken, linkId });
});
describe('reserve', () => {
    it(`root reserve`, async () => {
        const ids = await root.reserve(3);
        chai_1.assert.equal(ids.length, 3);
    });
    it(`admin reserve`, async () => {
        const ids = await deep.reserve(3);
        chai_1.assert.equal(ids.length, 3);
    });
});
//# sourceMappingURL=reserve.js.map